/*
 * ComponentesFrame.java
 *
 * Created on 28 de abril de 2007, 05:45 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.JPanel.*;
import javax.swing.JLabel.*;
import javax.swing.JMenu.*;
import java.awt.Toolkit.*;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem.*;
import javax.swing.JMenuItem;
/**
 * Esta clase me define el Frame, sobre el cual se va a
 * dibujar el menu, el centro de dibujos donde se dibujan
 * las componentes electricas, y el label, donde se pone
 * informacion de interes.
 * @author Francisco Olivares
 * @author Cristhoper Jana
 */
public class ComponentesFrame extends javax.swing.JFrame{
    /** Este es el menu, el cual se va a agregar al frame
     */
    private JMenuBar menuBar;
    /** Este es el tamano inicial de la pantalla, ancho
     */
    private final int sizeX = 640;
    /** Este es el tamano inicial de la pantalla, alto
     */
    private final int sizeY = 480;
    /** Este es el container donde estara situado tanto el
     *  JPanel, como el label.
     */
    private Container contentPane;
    /** Este objeto es el quie contiene el label, y metodos para
     *  setear y obtener su texto.
     */
    protected InfoLabel informacionesLabel;
    /** Este me define el Panel y su pantalla grafica, el cual es agragado
     *  al JFrame.
     */
    protected ComponentesPanel panelPrincipal;
    /** Este es una interfaz a el label.
     */
    private InfoInterfaz informacionLabel;
    /** Creates a new instance of ComponentesFrame
     */
    public ComponentesFrame() {
        this.setLayout(new BorderLayout());
        this.setTitle("Componentes Electricas");
        this.setDefaultCloseOperation(this.EXIT_ON_CLOSE);
        creaLosMenus();
        this.setJMenuBar(menuBar);
        contentPane = this.getContentPane();
        creaLaPantalla();
        MenusListeners.setInfoInterfaz(informacionesLabel);
        MouseInputListeners.setPanelGraficoInterfaz(panelPrincipal);
        MouseMotionListeners.setPanelGraficoInterfaz(panelPrincipal);
        MenusListeners.setPanelGraficoInterfaz(panelPrincipal);
        pack();
        this.setSize(sizeX,sizeY);
        this.setResizable(true);
        Toolkit kit = Toolkit.getDefaultToolkit();
        Dimension screenSize = kit.getScreenSize();
        this.setBounds( (screenSize.width  - sizeX)/2,
                        (screenSize.height - sizeY)/2,
                        sizeX , sizeY);
    }
    /** Este metodo privado me hace los menus, se creo asi para tener mas
     *  orden en el programa
     */
    private void creaLosMenus() {
        menuBar = new JMenuBar();

        // primer menu
        JMenu crear = new JMenu("Crear");
        menuBar.add(crear);

        JMenuItem resistencia = new JMenuItem("Resistencia");
        crear.add(resistencia);
        resistencia.addActionListener(new
                                MenusListeners(MenusListeners.RESISTENCIA));

        JMenuItem tierra = new JMenuItem("Tierra");
        crear.add(tierra);
        tierra.addActionListener(new MenusListeners(MenusListeners.TIERRA));

        JMenuItem fuente = new JMenuItem("Fuente");
        crear.add(fuente);
        fuente.addActionListener(new MenusListeners(MenusListeners.FUENTE));

        // segundo menu
        JMenu editar = new JMenu("Editar");
        menuBar.add(editar);

        JMenuItem trasladar = new JMenuItem("Trasladar");
        editar.add(trasladar);
        trasladar.addActionListener(new MenusListeners(MenusListeners.TRASLADAR));

        JMenuItem rotar = new JMenuItem("Rotar");
        editar.add(rotar);
        rotar.addActionListener(new MenusListeners(MenusListeners.ROTAR));
    }
    /** Este metodo privado me pega todas cosas en el frame
     */
    private void creaLaPantalla() {
        informacionesLabel = new InfoLabel();
        panelPrincipal = new ComponentesPanel();
        panelPrincipal.setBackground(Color.lightGray);
        contentPane.add(panelPrincipal,BorderLayout.CENTER);
        contentPane.add(informacionesLabel.getLabel(),BorderLayout.SOUTH);
    }
}
