/*
 * ListaDeLineas.java
 *
 * Created on 30 de abril de 2007, 11:52 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.awt.*;
import java.awt.geom.*;
import java.lang.Math;
import java.lang.String.*;
import java.lang.Object.*;
import java.io.*;
import java.util.Scanner;
import java.util.ArrayList.*;
import java.util.*;
import java.awt.geom.Point2D.Double;
/**
 * Esta clase tiene un array list que tiene todas las componentes electricas
 * que se han creado durante la secion del programa.
 * @author Francisco Olivares
 * @author Cristhoper Jana
 */
public class ListaDeLineas extends Linea implements ListaDeLineasInterfaz {
    /** Esta linea es un respaldo de la figura que ha sido tomada con el
     *  mouse, ante cualquier evento de soltar, ya que la otra figura
     *  reliza el movimiento mientras se arrastra el mouse.
     */
    public Linea lineaOComponenteElectricoTomadoRespaldo;
    /** Esta linea es la que se mueve cuando el usario mueve el mouse,
     *  y tiene el comando mover activado.
     */
    public Linea lineaOComponenteElectricoTomado;
    /** Este arrayList es el arreglo donde se van a agregar las Lineas
     *  que representan las componentes electricas.
     */
    protected ArrayList<Linea> Componentes;
    /** Creates a new instance of ListaDeLineas
     */
    public ListaDeLineas() {
        Componentes = new ArrayList<Linea>();
    }
    /** Este metodo me permite eliminar la Componente i
     */
    public void del(int i) {
        Componentes.remove(i);
    }
    /** Este metodo permite agregar Formas
     *  @param x La componente a agregar
     */
    public void add(Linea x) {
        Componentes.add(x);
    }
    /** Este metodo entrega la forma numero i
     *  @param i Este entero representa el numero de Componente que se va
     * a extraer
     *  @return Linea Da la Componente en la casilla numero i
     */
    public Linea get(int i) {
        return (Componentes.get(i));
    }
    /** Este metodo entrega la cantidad de Compoenentes electricas,
     *  resistencioas, fuentes y tierras; que estan en este objeto.
     *  @return Entrega tipo entero con la cantidad de Componentes adjuntadas
     */
    public int size() {
        return(Componentes.size());
    }
    /** Metodo que permite mover la componente tomada.
     */
    public void mover(int x, int y) {
        lineaOComponenteElectricoTomado.mover(x,y);
    }
    /** Metodo que permite rotar la componente tomada.
     */
    public void rotar() {
        lineaOComponenteElectricoTomado.rotar();
    }
    /** Metodo que llama a que las figuras se dibujen en la pantalla.
     */
    public Graphics dibujate(Graphics g) {
        Color paraCadaFigura;
        for(int i=0;i<Componentes.size(); i++) {
            paraCadaFigura = Componentes.get(i).getColor();
            g.setColor(paraCadaFigura);
            Componentes.get(i).dibujate(g);
        }
        if(lineaOComponenteElectricoTomado != null) {
            g.setColor(Color.RED);
            lineaOComponenteElectricoTomado.dibujate(g);
        }
        return(g);
    }
    /** Esta funcion cambia por si sola los colores de las Componentes
     *  que contengan al punto con valores x e y.
     *  @return verdadero si hay una figura en el punto, y falso si no hay
     *  ninguna
     */
    public boolean contiene(int x, int y) {
        boolean hayAlgoEnEsePunto = false;
        for(int i=0;i<Componentes.size(); i++) {
            if(Componentes.get(i).contiene(x,y)) {
                Componentes.get(i).cambioDeColor(Color.RED);
                hayAlgoEnEsePunto = true;
            }
            else {
                Componentes.get(i).cambioDeColor(Color.BLACK);
            }
        }
        return(hayAlgoEnEsePunto);
    }
    /** Metodo que permite tomar una compoenenet que este donde este el
     *  mouse, si no hay nada no hace nada.
     */
    public void tomarComponente(int x, int y) {
        for(int i=0;i<Componentes.size(); i++) {
            if(Componentes.get(i).contiene(x,y)) {
                lineaOComponenteElectricoTomado =
                        (Linea)Componentes.get(i).clone();
                lineaOComponenteElectricoTomadoRespaldo =
                        (Linea)Componentes.get(i).clone();
                Componentes.remove(i);
                break;
            }
        }
        for(int i=0;i<Componentes.size(); i++) {
            Componentes.get(i).cambioDeColor(Color.BLACK);
        }
    }
    /** Metodo que permite soltar la componenete, que previamente
     *  se ha creado.
     */
    public void soltarComponente() {
        Componentes.add(lineaOComponenteElectricoTomado);
        lineaOComponenteElectricoTomado = null;
        lineaOComponenteElectricoTomadoRespaldo = null;
    }
    /** metodo para saber si una componente ha sido creada.
     */
    public boolean tengoTomadaUnaComponente() {
        return(lineaOComponenteElectricoTomado != null);
    }
    /** Recarga la componente tomada con la del respaldo,
     *  para el caso en que se suelte, ademas sirve para poder setear
     *  la posicion definitiva.
     */
    public void recargarComponenteTomadaConRespaldo() {
        lineaOComponenteElectricoTomado =
                (Linea)lineaOComponenteElectricoTomadoRespaldo.clone();
    }
    /** Metodo no implementado aqui que permite vaciar el arraylist, de
     *  circulos radiales, los cuales me indican cercania.
     */
    public void vaciaElArregloDeCirculosRadiales() {
        // NO IMPLEMENTADO A ESTE NIVEL,
        // SU HIJO LO IMPLEMENTA.
    }
}
