/*
 * ListaDeLineasNueva.java
 *
 * Created on 1 de mayo de 2007, 09:57 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.awt.*;
import java.awt.geom.*;
import java.lang.Math;
import java.lang.String.*;
import java.lang.Object.*;
import java.io.*;
import java.util.Scanner;
import java.util.ArrayList.*;
import java.util.*;
import java.awt.geom.Point2D.Double;
import java.awt.geom.Ellipse2D;
import java.awt.Rectangle;
import java.awt.Graphics;
/**
 *  Clase que extiende de lista de lineas, que me da mas funcionalidad,
 *  sobre la base funcional.
 * @author Francisco Olivares
 * @author Cristhoper Jana
 */
public class ListaDeLineasNueva extends ListaDeLineas
                                implements ListaDeLineasInterfaz {
    private final int RADIODECERCANIAMAGNETICA = 10;
    ArrayList<Ellipse2D.Double> circulosRadiales;
    /** Creates a new instance of ListaDeLineasNueva */
    public ListaDeLineasNueva() {
        super();
    }
    /** Este metodo me permite moverme por las figuras, he ir verificando
     *  si estoy cerca de algun vertice, si es asi, se pegan los puntos,
     *  semejando a vertices magneticos, cabe destacar que se genra un array
     *  list de circulos solo cuando se toma una compoente y se arrastra, y se
     *  destruye cuando este se suelta.
     */
    public void mover(int x, int y) {
        double x1,y1,x2,y2;
        // si no existen los circulos radiales se construyen.
        if(circulosRadiales == null) {
            Ellipse2D.Double elipse;
            circulosRadiales = new ArrayList<Ellipse2D.Double>();
            for(int i=0;i<Componentes.size(); i++) {
                x1 = Componentes.get(i).getArribaIzquierda().getX();
                y1 = Componentes.get(i).getArribaIzquierda().getY();
                x2 = Componentes.get(i).getAbajoDerecha().getX();
                y2 = Componentes.get(i).getAbajoDerecha().getY();
                elipse = new Ellipse2D.Double(x1-RADIODECERCANIAMAGNETICA,
                                              y1-RADIODECERCANIAMAGNETICA,
                                              RADIODECERCANIAMAGNETICA*2,
                                              RADIODECERCANIAMAGNETICA*2);
                circulosRadiales.add(elipse);
                elipse = new Ellipse2D.Double(x2-RADIODECERCANIAMAGNETICA,
                                              y2-RADIODECERCANIAMAGNETICA,
                                              RADIODECERCANIAMAGNETICA*2,
                                              RADIODECERCANIAMAGNETICA*2);
                circulosRadiales.add(elipse);
            }// tengo todos los circulos radiales generados
        }
        // primero la componente deberia moverse
        super.mover(x,y);
        // deberia sacar la posicion de la componente y...
        int x2m =
             (int)lineaOComponenteElectricoTomado.getArribaIzquierda().getX();
        int y2m =
             (int)lineaOComponenteElectricoTomado.getArribaIzquierda().getY();
        int x1m =
             (int)lineaOComponenteElectricoTomado.getAbajoDerecha().getX();
        int y1m =
             (int)lineaOComponenteElectricoTomado.getAbajoDerecha().getY();
        // ver si esta esta dentro del area de algun circulo radial,
        // si es asi, posicionar la componente en el punto central del
        // circulo radial y el otro punto moverlo proporcionalmente al
        // movimiento anterior.
        for(int i=0;i<circulosRadiales.size(); i++) {
            // COMPRUEBA SI EL PUNTO DE MAS ARRIBA A LA IZQUIERDA ESTA
            // CONTENIDO EN UN CIRCULO RADIAL
            if(circulosRadiales.get(i).contains(x2m,y2m)) {
                int deltaMovimientoX =
                        (int)circulosRadiales.get(i).getCenterX() -
                        lineaOComponenteElectricoTomado.getArribaIzquierdaX();
                int deltaMovimientoY =
                        (int)circulosRadiales.get(i).getCenterY() -
                        lineaOComponenteElectricoTomado.getArribaIzquierdaY();
                lineaOComponenteElectricoTomado.setArribaIzquierda(
                        deltaMovimientoX +
                        lineaOComponenteElectricoTomado.getArribaIzquierdaX(),
                        deltaMovimientoY +
                        lineaOComponenteElectricoTomado.getArribaIzquierdaY());
                lineaOComponenteElectricoTomado.setAbajoDerecha(
                        deltaMovimientoX +
                        lineaOComponenteElectricoTomado.getAbajoDerechaX(),
                        deltaMovimientoY +
                        lineaOComponenteElectricoTomado.getAbajoDerechaY());
                        break;
            }
            // COMPRUEBA SI EL PUNTO DE MAS ABAJO A LA DERCHA ESTA
            // CONTENIDO EN UN CIRCULO RADIAL
            else if(circulosRadiales.get(i).contains(x1m,y1m)) {
                int deltaMovimientoX =
                        (int)circulosRadiales.get(i).getCenterX() -
                            lineaOComponenteElectricoTomado.getAbajoDerechaX();
                int deltaMovimientoY =
                        (int)circulosRadiales.get(i).getCenterY() -
                            lineaOComponenteElectricoTomado.getAbajoDerechaY();
                lineaOComponenteElectricoTomado.setAbajoDerecha(
                        deltaMovimientoX +
                        lineaOComponenteElectricoTomado.getAbajoDerechaX(),
                        deltaMovimientoY +
                        lineaOComponenteElectricoTomado.getAbajoDerechaY());
                lineaOComponenteElectricoTomado.setArribaIzquierda(
                        deltaMovimientoX +
                        lineaOComponenteElectricoTomado.getArribaIzquierdaX(),
                        deltaMovimientoY +
                        lineaOComponenteElectricoTomado.getArribaIzquierdaY());
                        break;
            }
        }
    }
    /** Metodo implementado aqui que permite vaciar el arraylist, de
     *  circulos radiales, los cuales me indican cercania.
     */
    public void vaciaElArregloDeCirculosRadiales() {
        circulosRadiales = null;
    }
}
